<?php

	$info['message'] = '';
	$info['success'] = false;

	$folder = 'uploads/';
	if(!file_exists($folder))
		mkdir($folder);

	if($_SERVER['REQUEST_METHOD'] == 'POST')
	{
		
		if($_POST['action'] == 'upload')
		{

			foreach ($_FILES as $files_array) {
				
				if(!empty($files_array['name']))
				{
					$type = $files_array['type'];
					$convert_to = $_POST['convert-to'];

					$allowed = ['image/jpeg','image/png','image/webp'];
					if(in_array($type, $allowed))
					{
						$destination = $folder . $files_array['name'];
						move_uploaded_file($files_array['tmp_name'], $destination);
						
						convert_file($destination, $type, $convert_to);

						$info['success'] = true;

					}else{
						$info['message'] = 'File type not allowed!';
					}
				}else{
					$info['message'] = 'Could not upload file';
				}	
			}
		}else
		if($_POST['action'] == 'delete')
		{
			$file = $_POST['filename'];
			if(file_exists($file))
				unlink($file);

			$info['success'] = true;
		}

		echo json_encode($info);
		die;
	}

	function convert_file($filename, $type, $convert_to)
	{
		if(!file_exists($filename))
			return;

		switch ($type) {
			case 'image/jpeg':
				$image = imagecreatefromjpeg($filename);
				break;

			case 'image/png':
				$image = imagecreatefrompng($filename);
				break;

			case 'image/webp':
				$image = imagecreatefromwebp($filename);
				break;
			
			default:
				$image = imagecreatefromjpeg($filename);
				break;
		}

		$parts = explode('.', $filename);
		$ext = end($parts);

		switch ($convert_to) {
			case 'image/jpeg':
				unlink($filename);
				imagejpeg($image, preg_replace("/\.$ext$/", ".jpg", $filename));
				break;

			case 'image/png':
				unlink($filename);
				imagepng($image, preg_replace("/\.$ext$/", ".png", $filename));
				break;

			case 'image/webp':
				unlink($filename);
				$image = imagewebp($image,preg_replace("/\.$ext$/", ".webp", $filename));
				break;
			
			default:
				unlink($filename);
				imagejpeg($image, preg_replace("/\.$ext$/", ".jpg", $filename));
				break;
		}

		
	}

	$images = glob($folder . '*.{jpeg,jpg,png,webp,JPEG,JPG,PNG,WEBP}',GLOB_BRACE);
?>
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Home</title>
	<meta name="description" content="">
  	<meta name="keywords" content="">
	<link rel="stylesheet" type="text/css" href="assets/css/bootstrap-icons.css">
	<link rel="stylesheet" type="text/css" href="assets/css/styles.css?2492">
</head>
<body>
	
	<section handle="true" class="section" >
		<div class="div-container" >
			<div class="div-container_3" >
				<h1  class="h1" >
					Image File Converter
				</h1>
				<input multiple onchange="upload_files(this.files)" accept="image/jpeg,image/png,image/webp" class="file-input" type="file" name="image" >
				<div handle="true" class="input-container" >
					<label  class="input-label" >
						Convert to:
					</label>
					<select class="input-control js-convert-to" >
						<option value="image/jpeg">
							Jpeg
						</option>
						<option value="image/png">
							PNG
						</option>
						<option value="image/webp">
							Webp
						</option>
					</select>
				</div>
				<div handle="true" class="progress" style="display: none;" >
					<div  class="progress-bar" style="width: 0%;" >
						0%
					</div>
				</div>
			</div>
			<div class="div-container_5" >
				
				<?php if(!empty($images)):?>
					<?php foreach($images as $img):?>
						<div class="div-container_14" >
							<div class="div-container_16" >
								<img class="img" src="<?=$img?>" >
							</div>
							<div class="div-container_18" >
								<div  class="class_1" >
									<?=basename($img)?>
								</div>
								<div  class="class_1_29" >
									<?=round(filesize($img) / 1024 / 1024,2)?>Mb
								</div>
							</div>
							<a href="download.php?img=<?=urlencode($img)?>" class="div-container_20" >
								<i class="bi bi-cloud-download-fill icon" >
								</i>
							</a>
							<div onclick="delete_file('<?=$img?>')" class="div-container_22" >
								<i class="bi bi-trash-fill icon_25" >
								</i>
							</div>
						</div>
	 				<?php endforeach?>
 				<?php else:?>
 					<div style="text-align: center;padding: 2em;opacity:0.5">No files uploaded yet</div>
 				<?php endif?>

			</div>
		</div>
	</section>
	
<script src="assets/js/script.js?7934"></script>

<script type="text/javascript">
	
	function upload_files(files)
	{
		let allowed = ['image/jpeg','image/png','image/webp'];

		let myform = new FormData;
		myform.append('action','upload');
		myform.append('convert-to',document.querySelector('.js-convert-to').value);

		for (var i = 0; i < files.length; i++) {
			if(allowed.includes(files[i].type))
			{
				myform.append('file'+i,files[i]);
			}else{
				alert("File not supported! "+files[i].name);
			}
		}

		document.querySelector('.progress').style.display = 'block';
		document.querySelector('.progress-bar').style.width = '0%';
		document.querySelector('.progress-bar').innerHTML = '0%';

		let xhr = new XMLHttpRequest;

		xhr.addEventListener('readystatechange',function(){

			if(xhr.readyState == 4)
			{
				if(xhr.status == 200)
				{
					//alert(xhr.responseText);
					let obj = JSON.parse(xhr.responseText);
					if(obj.success)
						window.location.reload();
					else
						alert(obj.message);
				}else{
					alert("Please check your connection");
				}
			}
		});

		xhr.upload.addEventListener('progress',function(e){

			 let percent = Math.round((e.loaded / e.total) * 100);
			 
			 document.querySelector('.progress-bar').style.width = percent + '%';
			 document.querySelector('.progress-bar').innerHTML = percent + '%';
		});


		xhr.open('POST','',true);
		xhr.send(myform);
	}

	function delete_file(filename)
	{
		if(!confirm("Are you sure you want to delete this file?!"))
			return;

		let myform = new FormData;
		myform.append('action','delete');
		myform.append('filename',filename);

		let xhr = new XMLHttpRequest;

		xhr.addEventListener('readystatechange',function(){

			if(xhr.readyState == 4)
			{
				if(xhr.status == 200)
				{
					
					let obj = JSON.parse(xhr.responseText);
					if(obj.success)
						window.location.reload();
					else
						alert(obj.message);
				}else{
					alert("Please check your connection");
				}
			}
		});
 
		xhr.open('POST','',true);
		xhr.send(myform);
	}

</script>
</body>
</html>